package main

import (
	"bufio"
	"context"
	"fmt"
	"io"
	"os"
	"path/filepath"
	"strings"

	"gitlab.com/hackandsla.sh/sqlc-gen-doc/plugin"
)

const header string = "<!-- Code generated by sqlc-gen-doc. DO NOT EDIT. -->"

func main() {
	if err := run(); err != nil {
		fmt.Fprintf(os.Stderr, "error generating JSON: %s", err)
		os.Exit(2)
	}
}

func run() error {
	var req plugin.CodeGenRequest
	reqBlob, err := io.ReadAll(os.Stdin)
	if err != nil {
		return err
	}

	if err := req.UnmarshalVT(reqBlob); err != nil {
		return err
	}

	var generator CodeGenerator = &DocGenerator{}

	resp, err := generator.Generate(context.Background(), &req)
	if err != nil {
		return err
	}

	respBlob, err := resp.MarshalVT()
	if err != nil {
		return err
	}
	w := bufio.NewWriter(os.Stdout)
	if _, err := w.Write(respBlob); err != nil {
		return err
	}
	if err := w.Flush(); err != nil {
		return err
	}
	return nil
}

type CodeGenerator interface {
	Generate(ctx context.Context, req *plugin.CodeGenRequest) (*plugin.CodeGenResponse, error)
}

type DocGenerator struct{}

func (dg *DocGenerator) Generate(ctx context.Context, req *plugin.CodeGenRequest) (*plugin.CodeGenResponse, error) {
	var files []*plugin.File
	for _, schema := range req.Catalog.Schemas {
		if schema.Name == "information_schema" || schema.Name == "pg_catalog" {
			continue
		}

		for _, table := range schema.Tables {
			var w strings.Builder
			fmt.Fprintln(&w, header)
			fmt.Fprintln(&w)
			fmt.Fprintf(&w, "# %s\n", table.Rel.Name)
			fmt.Fprintln(&w)
			fmt.Fprintf(&w, "Schema: %s\n", schema.Name)
			fmt.Fprintln(&w)

			for _, column := range table.Columns {
				fmt.Fprintf(&w, "- %s\n", column.Name)
			}

			files = append(files, &plugin.File{
				Name:     filepath.Join("tables", table.Rel.Name+".md"),
				Contents: []byte(w.String()),
			})
		}
	}

	return &plugin.CodeGenResponse{
		Files: files,
	}, nil
}
